#pragma once

class CLMRegValue {
public:
	enum {
		LMREGTYPE_BOOL,
		LMREGTYPE_NIL,
		LMREGTYPE_INTEGER,
		LMREGTYPE_POINTER,
		LMREGTYPE_CONST_POINTER,
		LMREGTYPE_STRING,
		LMREGTYPE_CONST_STRING,
		LMREGTYPE_STRINGPAIR,
		LMREGTYPE_CONST_STRINGPAIR,
		LMREGTYPE_MESSAGE,
	} ;
protected:
	int			m_iType ;
public:
	CLMRegValue () : m_iType (LMREGTYPE_NIL) {
		return ;
	}
	CLMRegValue (iType) : m_iType (iType) {
		return ;
	} 
	virtual		~CLMRegValue () {
		return ;
	}
} ;

class CLMRegInteger : public CLMRegValue {
private:
	int			m_iValue ;
public:
	CLMRegInteger () : CLMRegValue (LMREGTYPE_INTEGER), m_iValue (0) {
		return ;
	}
	CLMRegInteger (int iValue) :  CLMRegValue (LMREGTYPE_INTEGER), m_iValue (iValue) {
		return ;
	} 
	virtual		~CLMRegInteger () {
		return ;
	}
} ;

class CLMRegNil : public CLMRegValue {
public:
	CLMRegNil () : CLMRegValue (LMREGTYPE_NIL) {
		return ;
	} 
	virtual	~CLMRegNil () {
		return ;
	}
} ;

class CLMRegPointer : public CLMRegPointer {
} ;

